/**
 * 
 */
package ca.uqam.info.latece.sboa.impl.algorithms;

import java.io.File;

import java.util.StringTokenizer;

import fr.inrialpes.exmo.align.util.GroupEval;
import fr.inrialpes.exmo.align.util.Procalign;
import fr.inrialpes.exmo.align.util.GroupAlign;

import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;

import ca.uqam.info.latece.sboa.impl.utils.StreamThread;

import ca.uqam.info.latece.sboa.inter.algorithms.Evaluation;

/**
 * @author J.F. Djoufak
 *
 */
public class EvaluationImpl implements Evaluation {

	String rep = null;

	public EvaluationImpl(String reprository) {
		rep = reprository;
	}

	public void alignTwoOntologies(String aClass, String pFile, String rClass,
			String onto1, String onto2, String oFile) {
		String[] argAO = new String[10];
		argAO[0] = "-i";argAO[1] = aClass;
		argAO[2] = "-p";argAO[3] = pFile;
		argAO[4] = "-r";argAO[5] = rClass;
		argAO[6] = "-o";argAO[7] = oFile;
		argAO[8] = onto1;argAO[9] = onto2;
		Procalign.main(argAO);
	}

	public void compareCouples(String aFile, String source, String target,
			String oClass, String pFile, String pref) {
		String[] argCC = new String[12];
		argCC[0] = "-o";argCC[1] = aFile;
		argCC[2] = "-s";argCC[3] = source;
		argCC[4] = "-t";argCC[5] = target;
		argCC[6] = "-i";argCC[7] = oClass;
		argCC[8] = "-p";argCC[9] = pFile;
		argCC[10] = "-w";argCC[11] = rep;
		//argCC[10] = "-u";argCC[11] = pref;
		GroupAlign.main(argCC);
	}

	public void referenceEval(String aFile, String ref, String aClass,
			String pFile, String rFile, String pref) {
		String[] argGA = new String[12];
		argGA[0] = "-o";argGA[1] =aFile;
		argGA[2] = "-n";argGA[3] = ref;
		argGA[4] = "-i";argGA[5] = aClass;
		argGA[6] = "-p";argGA[7] = pFile;
		argGA[8] = "-w";argGA[9] = rep;
		argGA[10] = "-u";argGA[11] = pref;
		GroupAlign.main(argGA);
		
		String[] argGE = new String[7];
		argGE[0] = "-c";
		argGE[1] = "-l";argGE[2] = aFile;
		argGE[3] = "-w";argGE[4] = rep;
		argGE[5] = "-o";argGE[6] = rFile;
		GroupEval.main(argGE);
	}
	
	public void diffToReference(String refFile, String alignFile, String outRep, String fName){
		File [] subdir = (new File(rep)).listFiles();
		  String path = null;
		  String command = "/bin/mkdir "+outRep;
		  execProc(0,command,"",1);
		  for(int i = 0 ; i < subdir.length ; i++){
		      if( subdir[i].isDirectory() ) {
			      try{
				      path = subdir[i].getAbsolutePath();
				      String name = subdir[i].getName();
					  command = "/bin/mkdir "+outRep+"/"+name;
					  execProc(0,command,"",1);
					  
					  boolean rTest = (new File(path+"/"+refFile)).exists();
					  boolean oTest = (new File(path+"/"+alignFile)).exists();
				      if ( rTest == true ) {
					      transform(path+"/"+refFile, "./scripts/txt-form-align.xsl",outRep+"/"+name+"/temp.txt");
						  command = "/bin/sort "+outRep+"/"+name+"/temp.txt";
						  execProc(2,command,outRep+"/"+name+"/reference.txt",1);
						 } 
					  if ( oTest == true ) {
					      transform(path+"/"+alignFile, "./scripts/txt-form-align.xsl",outRep+"/"+name+"/temp.txt");
						  command = "/bin/sort "+outRep+"/"+name+"/temp.txt";
						  execProc(2,command,outRep+"/"+name+"/alignment.txt",1);
						 }
					  if ( (rTest == true) && (oTest == true) ){
						  command = "./scripts/compare "+outRep+"/"+name+"/reference.txt "
						  +outRep+"/"+name+"/alignment.txt "+outRep+"/"+name+"/"+fName;
						  execProc(0,command,"",1);
						  command = "/bin/rm "+outRep+"/"+name+"/temp.txt";
						  execProc(0,command,"",1);
					  }
				     }
				  catch (Exception e) { e.printStackTrace();System.exit(1); } 
			     }
			 }
	}
	
	public boolean transform(String sourceFile, String xsltFile, String resultFile) {
        boolean state;
		try {
            StreamSource xmlFile = new StreamSource(new File(sourceFile));            
            StreamSource xsltTransf = new StreamSource(new File(xsltFile));
            TransformerFactory xsltFactory = TransformerFactory.newInstance();
            Transformer transformer = xsltFactory.newTransformer(xsltTransf);
            StreamResult resultStream = new StreamResult(resultFile);
            transformer.transform(xmlFile, resultStream);
            state = true;
        } catch (Exception exp) {
            //exp.printStackTrace();
            state = false;
        }
	 return state;
    }
	
	public void execProc(int write, String command, String fileName, int wait){
	      Process p;
	      try {
	          p = Runtime.getRuntime().exec(command);
			  StreamThread errorS =new StreamThread(p.getErrorStream(), "ERROR",write,"");
			  StreamThread outputS = new StreamThread(p.getInputStream(), "OUTPUT",write,fileName);
			  errorS.start();outputS.start();
			  if (wait == 1) {p.waitFor();}
	         }
	      catch (Throwable t) {
	          System.out.println("Execution aborted: ");t.printStackTrace();
	         }
	     }
	
	public void buildResultDirectory(String outDir, String resFile, String outFile, boolean mDirs){
		File [] subdir = (new File(rep)).listFiles();
		  String path = null;
		  String command = "/bin/mkdir "+outDir;
		  execProc(0,command,"",1);
		  for(int i = 0 ; i < subdir.length ; i++){
		      if( subdir[i].isDirectory() ) {
			      try{
				      path = subdir[i].getAbsolutePath();
				      String name = subdir[i].getName();
					  if (mDirs == true){
						  command = "/bin/mkdir "+outDir+"/"+name;
						  execProc(0,command,"",1);
						  
						  command = "/bin/cp "+path+"/"+resFile+" "+outDir+"/"+name+"/"+outFile;
						  execProc(1,command,"",1);
					  }
					  else{
						  command = "/bin/cp "+path+"/"+resFile+" "+outDir+"/"+name+".rdf";
						  execProc(0,command,"",1);
						  /*String src = "file:"+"\\"+"/home"+"\\"+"/exmo"+"\\"+"/djoufakk"+"\\"+
						  "/oaei07"+"\\"+"/"+rep+"\\"+"/"+name+"\\"+"/"+"source.owl";
						  String tgt = "file:"+"\\"+"/home"+"\\"+"/exmo"+"\\"+"/djoufakk"+"\\"+
						  "/oaei07"+"\\"+"/"+rep+"\\"+"/"+name+"\\"+"/"+"target.owl";
						  String oaei = "http:"+"\\"+"/"+"\\"+"/";
						  StringTokenizer st = new StringTokenizer(name,"-");
						  boolean first = true;
						  String last = "";
						  while (st.hasMoreTokens()){
							  String tok = st.nextToken();
							  if (first == true){
								  command = "/usr/bin/perl -pi -e \"s/"+src+"/"+oaei+tok.toLowerCase()+"/g\""+" "+outDir+"/"+name+".rdf";
								  System.out.println(command);
								  command = "/usr/bin/perl -pi -e \"s/"+oaei+tok.toLowerCase()+"/"+oaei+tok+".owl"+"/g\""+" "+outDir+"/"+name+".rdf";
								  System.out.println(command);
								  first = false;
								  last = tok;
							  }
							  else{
								  if (!last.equalsIgnoreCase(tok)){
									  command = "/usr/bin/perl -pi -e \"s/"+tgt+"/"+oaei+tok.toLowerCase()+"/g\""+" "+outDir+"/"+name+".rdf"; 
									  System.out.println(command);
									  command = "/usr/bin/perl -pi -e \"s/"+oaei+tok.toLowerCase()+"/"+oaei+tok+".owl"+"/g\""+" "+outDir+"/"+name+".rdf";
									  System.out.println(command);
								  }
								  else{
									  command = "/usr/bin/perl -pi -e \"s/"+tgt+"/"+oaei+tok+".owl"+"/g\""+" "+outDir+"/"+name+".rdf"; 
									  System.out.println(command);
								  }
							  }
							  //execProc(2,command,outDir+"/"+name+".rdf",0); 
						  }*/
					  }
					  
					  command = "/bin/rm "+path+"/"+resFile;
					  execProc(0,command,"",1);
			      }
			      catch(Exception e){
			    	  e.printStackTrace();System.exit(1);
			      }
		      }
		  }
	}

}
