/**
 * 
 */
package ca.uqam.info.latece.sboa.impl.selection;

import no.uib.cipr.matrix.Matrix;
import no.uib.cipr.matrix.DenseMatrix;
import no.uib.cipr.matrix.Matrices;

import ca.uqam.info.latece.sboa.inter.selection.AssignmentMethods;


/**
 * @author J.F. Djoufak
 *
 */
public class AssignmentMethodsImpl implements AssignmentMethods {

	int nbRow = 0;
	int nbCol = 0;

	public AssignmentMethodsImpl() {
		
	}

	public Matrix greedy(Matrix matrix) {
		nbRow = matrix.numRows();
		nbCol = matrix.numColumns();
		int minSize = (nbRow >= nbCol) ? nbCol : nbRow;
		Matrix cmatrix = matrix.copy();
		Matrix result = new DenseMatrix(minSize,2);
		for (int k = 0 ; k < minSize ; k++){
			double max_val = 0.0;
            int max_i = 0;
            int max_j = 0;
            for (int i = 0 ; i < nbRow ; i++){
            	for (int j = 0 ; j < nbCol ; j++){
            		double curr_val = cmatrix.get(i,j);
            		if (max_val < curr_val){
                        max_val = curr_val;
                        max_i = i;
                        max_j = j;
                    }
            	}
            }
            result.set(k,0, max_i);
            result.set(k,1,max_j);
            for (int i = 0 ; i < nbRow ; i++){cmatrix.set(i,max_j,0.0);}
            for (int j = 0 ; j < nbCol ; j++){cmatrix.set(max_i,j,0.0);}
		}
		return result;
	}
	
	public Matrix hungarian(Matrix matrix){
		Matrix result = null;
		int numRows = matrix.numRows();
		int numCols = matrix.numColumns();
		if ((numCols > 1) &&(numRows > 1)){
			int[][] assignment = new int[numRows][2];
			double[][] array = Matrices.getArray(matrix);
			assignment = HungarianAlgorithm.hgAlgorithm(array,"max");
			result = new DenseMatrix(numRows,2);
			for (int i = 0 ; i < numRows ; i++){
				for (int j = 0 ; j < 2 ; j++){
					result.set(i,j, assignment[i][j]);
				}
			}
		}
		else{
			result = greedy(matrix);
		}
		return result;
	}

}
