/**
 * 
 */
package ca.uqam.info.latece.sboa.impl.utils;

import java.util.ArrayList;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @author J.F. Djoufak
 *
 */
public class LabelTokenizer {
	int nbToken = 0;

	public LabelTokenizer() {
		
	}
	
	public ArrayList<String> tokenize(String name){
		ArrayList<String> result = new ArrayList<String>();
		ArrayList<Integer> delim = new ArrayList<Integer>();
		int dsz = 0;
		nbToken = 0;
		String regex = "[A-Z]+[0-9]*[A-Z]+|([A-Z]+[a-z]*([-]+[A-Z]*[a-z]*)+)|([A-Z]\\.)+|" +
				"[A-Z]+|[-+]?[0-9]*\\.?[0-9]+([eE][-+]?[0-9]+)?|\\s|" +
				"[,]|[{]|[}]|[:]|[_]";
		Pattern p = Pattern.compile(regex);
		Matcher m = p.matcher(name);
		while(m.find()){
            delim.add(m.start());dsz++;
        }
		delim.add(new Integer(name.length()));dsz++;
		int start = 0;
		for(int i = 0 ; i < dsz ; i++){
			int end = delim.get(i).intValue();
			String tok = name.substring(start,end);
			start = end;
			if (saveToken(tok)){
				tok = tok.replace("_","");
				tok = tok.replace(".","");
				result.add(tok);
				nbToken++;
			}	
		}
		return result;
	}
	
	public boolean saveToken(String tok){
		boolean result = true;
		result = result && (!tok.equalsIgnoreCase(""));
		result = result && (!tok.equalsIgnoreCase(" "));
		result = result && (!tok.equalsIgnoreCase("}"));
		result = result && (!tok.equalsIgnoreCase("{"));
		result = result && (!tok.equalsIgnoreCase(","));
		result = result && (!tok.equalsIgnoreCase(":"));
		result = result && (!tok.equalsIgnoreCase("_"));
		return result;
	}
	
	public ArrayList<String> tokenizePath(String path){
		ArrayList<String> result = new ArrayList<String>();
		nbToken = 0;
		int end = 0;
		int start = 0;
		int parCount = 0;
		int pLen = path.length();
		for(int i = 0 ; i < pLen ; i++){
			char c = path.charAt(i);
			if (c == '('){parCount++;}
			if (c == ')'){parCount--;}
			if (parCount == 0){
				end = i+1;
				String tok = path.substring(start,end);
				tok = tok.replace("(","");
				tok = tok.replace(")","");
				result.add(tok);
				nbToken++;
				start = end;
			}
		}
		return result;
	}
	
	public int getNumberOfTokens(){
		return nbToken;
	}

}
