/**
 * 
 */
package ca.uqam.info.latece.sboa.impl.weights;

import org.semanticweb.owl.align.Parameters;

import ca.uqam.info.latece.sboa.inter.weights.Capture;

/**
 * @author J.F. Djoufak
 *
 */
public class OLAWeightCapture implements Capture {

	Parameters params = null;
	
	private double threshold = 0.79;//int value = 0
	private double epsillon = 0.01;//int value = 1
	
	private double Class_Lexical = Math.sqrt(0.5);//int value = 2
	private double Class_Object = Math.sqrt(0.1);//int value = 3
	private double Class_SuperClass = Math.sqrt(0.1);//int value = 4
	private double Class_ObjectProperty = Math.sqrt(0.1);//int value = 5
	private double Class_DatatypeProperty = Math.sqrt(0.2);//int value = 6
	
	private double ObjectProperty_Lexical = Math.sqrt(0.2);//int value = 7 [Unused since ND]
	private double ObjectProperty_Class = Math.sqrt(0.3);//int value = 8
	private double ObjectProperty_Object = Math.sqrt(0.0);//int value = 9 [Unused since ND]
	private double ObjectProperty_Cardinality = Math.sqrt(0.1);//int value = 10
	private double ObjectProperty_Relation = Math.sqrt(0.4);//int value = 11
	
	private double DatatypeProperty_Lexical = Math.sqrt(0.2);//int value = 12 [Unused since ND]
	private double DatatypeProperty_Datatype = Math.sqrt(0.3);//int value = 13
	private double DatatypeProperty_DatatypeValue = Math.sqrt(0.0);//int value = 14 [Unused since ND]
	private double DatatypeProperty_Cardinality = Math.sqrt(0.1);//int value = 15
	private double DatatypeProperty_Relation = Math.sqrt(0.4);//int value = 16
	
	private double DatatypeRelation_Lexical = Math.sqrt(0.5);//int value = 17
	private double DatatypeRelation_Domain = Math.sqrt(0.1);//int value = 18
	private double DatatypeRelation_Range = Math.sqrt(0.4);//int value = 19
	private double DatatypeRelation_SuperRelation = Math.sqrt(0.0);//int value = 20
	
	private double ObjectRelation_Lexical = Math.sqrt(0.5);//int value = 21
	private double ObjectRelation_Domain = Math.sqrt(0.1);//int value = 22
	private double ObjectRelation_Range = Math.sqrt(0.4);//int value = 23
	private double ObjectRelation_SuperRelation = Math.sqrt(0.0);//int value = 24
	
	private double Object_Lexical = Math.sqrt(1.0);//int value = 25
	private double Object_DatatypePropertyInstance = Math.sqrt(0.0);//int value = 26
	private double Object_ObjectPropertyInstance = Math.sqrt(0.0);//int value = 27
	private double Object_Class = Math.sqrt(0.0);//int value = 28 [Unused since ND]
	
	private double DatatypePropertyInstance_Lexical = Math.sqrt(0.4);//int value = 29 [Unused since ND]
	private double DatatypePropertyInstance_DatatypeValue = Math.sqrt(0.2);//int value = 30
	private double DatatypePropertyInstance_Relation = Math.sqrt(0.4);//int value = 31
	
	private double ObjectPropertyInstance_Lexical = Math.sqrt(0.4);//int value = 32 [Unused since ND]
	private double ObjectPropertyInstance_Object = Math.sqrt(0.2);//int value = 33
	private double ObjectPropertyInstance_Relation = Math.sqrt(0.4);//int value = 34
	private double noinst = 0;//int value = 35
	
	private int numberOfParameters = 36;

	public OLAWeightCapture() {
		
	}
	
	public OLAWeightCapture(Parameters par) {
		if (par != null){
			init(par);
		}
	}

	public void init(Parameters par) {
		params = par;
		for (int i = 0 ; i <= numberOfParameters ; i++){
			if (existWeight(i)){
				double val = Double.valueOf(retrieveWeight(i));
				if (i != 0){
					setWeight(i,Math.sqrt(val));
				}
				else{
					setWeight(i,val);
				}
			}
		}
		
	}

	public void setWeight(int pId, double val) {
		switch (pId)  {
		case 0:
			threshold = val;
			break;
		case 1:
			epsillon = val;
			break;
		case 2:
			Class_Lexical = val;
			break;
		case 3:
			Class_Object = val;
			break;
		case 4:
			Class_SuperClass = val;
			break;
		case 5:
			Class_ObjectProperty = val;
			break;
		case 6:
			Class_DatatypeProperty = val;
			break;
		case 7:
			ObjectProperty_Lexical = val;
			break;
		case 8:
			ObjectProperty_Class = val;
			break;
		case 9:
			ObjectProperty_Object = val;
			break;
		case 10:
			ObjectProperty_Cardinality = val;
			break;
		case 11:
			ObjectProperty_Relation = val;
			break;
		case 12:
			DatatypeProperty_Lexical = val;
			break;
		case 13:
			DatatypeProperty_Datatype = val;
			break;
		case 14:
			DatatypeProperty_DatatypeValue = val;
			break;
		case 15:
			DatatypeProperty_Cardinality = val;
			break;
		case 16:
			DatatypeProperty_Relation = val;
			break;
		case 17:
			DatatypeRelation_Lexical = val;
			break;
		case 18:
			DatatypeRelation_Domain = val;
			break;
		case 19:
			DatatypeRelation_Range = val;
			break;
		case 20:
			DatatypeRelation_SuperRelation = val;
			break;
		case 21:
			ObjectRelation_Lexical = val;
			break;
		case 22:
			ObjectRelation_Domain = val;
			break;
		case 23:
			ObjectRelation_Range = val;
			break;
		case 24:
			ObjectRelation_SuperRelation = val;
			break;
		case 25:
			Object_Lexical = val;
			break;
		case 26:
			Object_DatatypePropertyInstance = val;
			break;
		case 27:
			Object_ObjectPropertyInstance = val;
			break;
		case 28:
			Object_Class = val;
			break;
		case 29:
			DatatypePropertyInstance_Lexical = val;
			break;
		case 30:
			DatatypePropertyInstance_DatatypeValue = val;
			break;
		case 31:
			DatatypePropertyInstance_Relation = val;
			break;
		case 32:
			ObjectPropertyInstance_Lexical = val;
			break;
		case 33:
			ObjectPropertyInstance_Object = val;
			break;
		case 34:
			ObjectPropertyInstance_Relation = val;
			break;
		case 35:
			noinst = val;
			break;
		}

	}
	
	public boolean existWeight(int pId){
		boolean result = false;
		
		switch (pId)  {
		case 0:
			result = params.getParameter("threshold") != null;
			break;
		case 1:
			result = params.getParameter("epsillon") != null;
			break;
		case 2:
			result = params.getParameter("Class_Lexical") != null;
			break;
		case 3:
			result = params.getParameter("Class_Object") != null;
			break;
		case 4:
			result = params.getParameter("Class_SuperClass") != null;
			break;
		case 5:
			result = params.getParameter("Class_ObjectProperty") != null;
			break;
		case 6:
			result = params.getParameter("Class_DatatypeProperty") != null;
			break;
		case 7:
			result = params.getParameter("ObjectProperty_Lexical") != null;
			break;
		case 8:
			result = params.getParameter("ObjectProperty_Class") != null;
			break;
		case 9:
			result = params.getParameter("ObjectProperty_Object") != null;
			break;
		case 10:
			result = params.getParameter("ObjectProperty_Cardinality") != null;
			break;
		case 11:
			result = params.getParameter("ObjectProperty_Relation") != null;
			break;
		case 12:
			result = params.getParameter("DatatypeProperty_Lexical") != null;
			break;
		case 13:
			result = params.getParameter("DatatypeProperty_Datatype") != null;
			break;
		case 14:
			result = params.getParameter("DatatypeProperty_DatatypeValue") != null;
			break;
		case 15:
			result = params.getParameter("DatatypeProperty_Cardinality") != null;
			break;
		case 16:
			result = params.getParameter("DatatypeProperty_Relation") != null;
			break;
		case 17:
			result = params.getParameter("DatatypeRelation_Lexical") != null;
			break;
		case 18:
			result = params.getParameter("DatatypeRelation_Domain") != null;
			break;
		case 19:
			result = params.getParameter("DatatypeRelation_Range") != null;
			break;
		case 20:
			result = params.getParameter("DatatypeRelation_SuperRelation") != null;
			break;
		case 21:
			result = params.getParameter("ObjectRelation_Lexical") != null;
			break;
		case 22:
			result = params.getParameter("ObjectRelation_Domain") != null;
			break;
		case 23:
			result = params.getParameter("ObjectRelation_Range") != null;
			break;
		case 24:
			result = params.getParameter("ObjectRelation_SuperRelation") != null;
			break;
		case 25:
			result = params.getParameter("Object_Lexical") != null;
			break;
		case 26:
			result = params.getParameter("Object_DatatypePropertyInstance") != null;
			break;
		case 27:
			result = params.getParameter("Object_ObjectPropertyInstance") != null;
			break;
		case 28:
			result = params.getParameter("Object_Class") != null;
			break;
		case 29:
			result = params.getParameter("DatatypePropertyInstance_Lexical") != null;
			break;
		case 30:
			result = params.getParameter("DatatypePropertyInstance_DatatypeValue") != null;
			break;
		case 31:
			result = params.getParameter("DatatypePropertyInstance_Relation") != null;
			break;
		case 32:
			result = params.getParameter("ObjectPropertyInstance_Lexical") != null;
			break;
		case 33:
			result = params.getParameter("ObjectPropertyInstance_Object") != null;
			break;
		case 34:
			result = params.getParameter("ObjectPropertyInstance_Relation") != null;
			break;
		case 35:
			result = params.getParameter("noinst") != null;
			break;
		}
		
		return result;
	}
	
	public String retrieveWeight(int pId){
		String result = null;
		
		switch (pId)  {
		case 0:
			result = params.getParameter("threshold").toString();
			break;
		case 1:
			result = params.getParameter("epsillon").toString();
			break;
		case 2:
			result = params.getParameter("Class_Lexical").toString();
			break;
		case 3:
			result = params.getParameter("Class_Object").toString();
			break;
		case 4:
			result = params.getParameter("Class_SuperClass").toString();
			break;
		case 5:
			result = params.getParameter("Class_ObjectProperty").toString();
			break;
		case 6:
			result = params.getParameter("Class_DatatypeProperty").toString();
			break;
		case 7:
			result = params.getParameter("ObjectProperty_Lexical").toString();
			break;
		case 8:
			result = params.getParameter("ObjectProperty_Class").toString();
			break;
		case 9:
			result = params.getParameter("ObjectProperty_Object").toString();
			break;
		case 10:
			result = params.getParameter("ObjectProperty_Cardinality").toString();
			break;
		case 11:
			result = params.getParameter("ObjectProperty_Relation").toString();
			break;
		case 12:
			result = params.getParameter("DatatypeProperty_Lexical").toString();
			break;
		case 13:
			result = params.getParameter("DatatypeProperty_Datatype").toString();
			break;
		case 14:
			result = params.getParameter("DatatypeProperty_DatatypeValue").toString();
			break;
		case 15:
			result = params.getParameter("DatatypeProperty_Cardinality").toString();
			break;
		case 16:
			result = params.getParameter("DatatypeProperty_Relation").toString();
			break;
		case 17:
			result = params.getParameter("DatatypeRelation_Lexical").toString();
			break;
		case 18:
			result = params.getParameter("DatatypeRelation_Domain").toString();
			break;
		case 19:
			result = params.getParameter("DatatypeRelation_Range").toString();
			break;
		case 20:
			result = params.getParameter("DatatypeRelation_SuperRelation").toString();
			break;
		case 21:
			result = params.getParameter("ObjectRelation_Lexical").toString();
			break;
		case 22:
			result = params.getParameter("ObjectRelation_Domain").toString();
			break;
		case 23:
			result = params.getParameter("ObjectRelation_Range").toString();
			break;
		case 24:
			result = params.getParameter("ObjectRelation_SuperRelation").toString();
			break;
		case 25:
			result = params.getParameter("Object_Lexical").toString();
			break;
		case 26:
			result = params.getParameter("Object_DatatypePropertyInstance").toString();
			break;
		case 27:
			result = params.getParameter("Object_ObjectPropertyInstance").toString();
			break;
		case 28:
			result = params.getParameter("Object_Class").toString();
			break;
		case 29:
			result = params.getParameter("DatatypePropertyInstance_Lexical").toString();
			break;
		case 30:
			result = params.getParameter("DatatypePropertyInstance_DatatypeValue").toString();
			break;
		case 31:
			result = params.getParameter("DatatypePropertyInstance_Relation").toString();
			break;
		case 32:
			result = params.getParameter("ObjectPropertyInstance_Lexical").toString();
			break;
		case 33:
			result = params.getParameter("ObjectPropertyInstance_Object").toString();
			break;
		case 34:
			result = params.getParameter("ObjectPropertyInstance_Relation").toString();
			break;
		case 35:
			result = params.getParameter("noinst").toString();
			break;
		}
		
		return result;
	}
	
	public double getWeight(int pId) {
		double result = 0.0;
		
		switch (pId)  {
		case 0:
			result = threshold;
			break;
		case 1:
			result = epsillon;
			break;
		case 2:
			result = Class_Lexical;
			break;
		case 3:
			result = Class_Object;
			break;
		case 4:
			result = Class_SuperClass;
			break;
		case 5:
			result = Class_ObjectProperty;
			break;
		case 6:
			result = Class_DatatypeProperty;
			break;
		case 7:
			result = ObjectProperty_Lexical;
			break;
		case 8:
			result = ObjectProperty_Class;
			break;
		case 9:
			result = ObjectProperty_Object;
			break;
		case 10:
			result = ObjectProperty_Cardinality;
			break;
		case 11:
			result = ObjectProperty_Relation;
			break;
		case 12:
			result = DatatypeProperty_Lexical;
			break;
		case 13:
			result = DatatypeProperty_Datatype;
			break;
		case 14:
			result = DatatypeProperty_DatatypeValue;
			break;
		case 15:
			result = DatatypeProperty_Cardinality;
			break;
		case 16:
			result = DatatypeProperty_Relation;
			break;
		case 17:
			result = DatatypeRelation_Lexical;
			break;
		case 18:
			result = DatatypeRelation_Domain;
			break;
		case 19:
			result = DatatypeRelation_Range;
			break;
		case 20:
			result = DatatypeRelation_SuperRelation;
			break;
		case 21:
			result = ObjectRelation_Lexical;
			break;
		case 22:
			result = ObjectRelation_Domain;
			break;
		case 23:
			result = ObjectRelation_Range;
			break;
		case 24:
			result = ObjectRelation_SuperRelation;
			break;
		case 25:
			result = Object_Lexical;
			break;
		case 26:
			result = Object_DatatypePropertyInstance;
			break;
		case 27:
			result = Object_ObjectPropertyInstance;
			break;
		case 28:
			result = Object_Class;
			break;
		case 29:
			result = DatatypePropertyInstance_Lexical;
			break;
		case 30:
			result = DatatypePropertyInstance_DatatypeValue;
			break;
		case 31:
			result = DatatypePropertyInstance_Relation;
			break;
		case 32:
			result = ObjectPropertyInstance_Lexical;
			break;
		case 33:
			result = ObjectPropertyInstance_Object;
			break;
		case 34:
			result = ObjectPropertyInstance_Relation;
			break;
		case 35:
			result = noinst;
			break;
		}
		
		return result;
	}

}
