/**
 * 
 */
package ca.uqam.info.latece.sboa.impl.weights;

import java.io.File;
import java.io.IOException;
import java.io.BufferedWriter;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;

import no.uib.cipr.matrix.Vector;

import no.uib.cipr.matrix.DenseVector;

import org.semanticweb.owl.align.Parameters;

import fr.inrialpes.exmo.align.impl.BasicParameters;

import ca.uqam.info.latece.sboa.inter.weights.Generate;

/**
 * @author J.F. Djoufak
 *
 */
public class OLAWeightGenerator implements Generate {

	Parameters par = null;
	
	Vector weights = null;
	Vector groupSize = null;
	Vector groupMax = null;
	Vector groupMin = null;
	Vector groupWeightInc = null;
	Vector corrGroup = null;
	Vector fixedGroup = null;
	
	String className = null;
	String classMethod = null;
	String excludeUris = null;
	
	double epsillon = 0.01;
	double noinst = 1.0;
	
	int nextPos = 0;

	public OLAWeightGenerator(String cName, String mName, String exUris, double eps, double noi) {
		className = cName;
		classMethod = mName;
		excludeUris = exUris;
		epsillon = eps;
		noinst = noi;
	}


	public int allParameterFiles(String bfName) {
		int result = 0;
		while (hasNext()){
			Vector gWeight = nextParameterSet();
			nextParameterFile(gWeight,bfName+result+".xml");
			result++;
		}
		return result;
	}


	public boolean hasNext() {
		
		return false;
	}


	public void initialize(String iFile) {
		Parameters params = BasicParameters.read(iFile);
		par = params;
		int nbW = Integer.valueOf(par.getParameter("Number_Of_Weights").toString());
		int nbG = Integer.valueOf(par.getParameter("Number_Of_Groups").toString());
		createVectors(nbW,nbG);
	}
	
	public void createVectors(int nbW, int nbG){
		weights = new DenseVector(nbW);
		groupSize = new DenseVector(nbG);
		groupMax = new DenseVector(nbG);
		groupMin = new DenseVector(nbG);
		groupWeightInc = new DenseVector(nbG);
		corrGroup = new DenseVector(nbG);
		fixedGroup = new DenseVector(nbG);
	}
	
	public void setGroups(int nbG){
		for(int i = 0 ; i < nbG ; i++){
			int gId = i+1;
			groupSize.set(i, Integer.valueOf(par.getParameter("Size_Of_Group_"+gId).toString()));
			groupWeightInc.set(i, Integer.valueOf(par.getParameter("Inc_In_Group_"+gId).toString()));
			fixedGroup.set(i, Integer.valueOf(par.getParameter("Fix_Group_"+gId).toString()));
			corrGroup.set(i, Integer.valueOf(par.getParameter("Corr_Group_"+gId).toString())-1);
		}
		groupMin.set(0,Double.valueOf(par.getParameter("Class_Lexical_Min").toString()));
		groupMin.set(1,Double.valueOf(par.getParameter("ObjectProperty_Lexical_Min").toString()));
		groupMin.set(2,Double.valueOf(par.getParameter("DatatypeProperty_Lexical_Min").toString()));
		groupMin.set(3,Double.valueOf(par.getParameter("DatatypeRelation_Lexical_Min").toString()));
		groupMin.set(4,Double.valueOf(par.getParameter("ObjectRelation_Lexical_Min").toString()));
		groupMin.set(5,Double.valueOf(par.getParameter("Object_Lexical_Min").toString()));
		groupMin.set(6,Double.valueOf(par.getParameter("DatatypePropertyInstance_Lexical_Min").toString()));
		groupMin.set(7,Double.valueOf(par.getParameter("ObjectPropertyInstance_Lexical_Min").toString()));
		groupMin.set(8,Double.valueOf(par.getParameter("threshold_Min").toString()));
		
		groupMax.set(0,Double.valueOf(par.getParameter("Class_Lexical_Max").toString()));
		groupMax.set(1,Double.valueOf(par.getParameter("ObjectProperty_Lexical_Max").toString()));
		groupMax.set(2,Double.valueOf(par.getParameter("DatatypeProperty_Lexical_Max").toString()));
		groupMax.set(3,Double.valueOf(par.getParameter("DatatypeRelation_Lexical_Max").toString()));
		groupMax.set(4,Double.valueOf(par.getParameter("ObjectRelation_Lexical_Max").toString()));
		groupMax.set(5,Double.valueOf(par.getParameter("Object_Lexical_Min").toString()));
		groupMax.set(6,Double.valueOf(par.getParameter("DatatypePropertyInstance_Lexical_Max").toString()));
		groupMax.set(7,Double.valueOf(par.getParameter("ObjectPropertyInstance_Lexical_Max").toString()));
		groupMax.set(8,Double.valueOf(par.getParameter("threshold_ax").toString()));
	}
	
	public void setWeights(){
		weights.set(0,Double.valueOf(par.getParameter("Class_Lexical_Min").toString()));
		weights.set(5,Double.valueOf(par.getParameter("ObjectProperty_Lexical_Min").toString()));
		weights.set(10,Double.valueOf(par.getParameter("DatatypeProperty_Lexical_Min").toString()));
		weights.set(15,Double.valueOf(par.getParameter("DatatypeRelation_Lexical_Min").toString()));
		weights.set(19,Double.valueOf(par.getParameter("ObjectRelation_Lexical_Min").toString()));
		weights.set(23,Double.valueOf(par.getParameter("Object_Lexical").toString()));
		weights.set(27,Double.valueOf(par.getParameter("DatatypePropertyInstance_Lexical_Min").toString()));
		weights.set(30,Double.valueOf(par.getParameter("ObjectPropertyInstance_Lexical_Min").toString()));
		weights.set(33,Double.valueOf(par.getParameter("threshold_Min").toString()));
	}


	public Vector nextParameterSet() {
		Vector result = null;
		
		return result;
	}
	
	public void nextParameterFile(Vector gWeigh,String fName){
		File resFile= new File(fName);
		FileOutputStream out = null; BufferedWriter f_out = null;
		String dTW = new String();
		try{
			resFile.createNewFile();
			out = new FileOutputStream(resFile);
			f_out = new BufferedWriter(new OutputStreamWriter(out,"UTF8"));
			dTW = "<alignmentAlgorithm>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"threshold\">" + Double.toString(gWeigh.get(33)) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"epsillon\">" + Double.toString(epsillon) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"noinst\">" + Double.toString(noinst) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"excludeURIs\">" + excludeUris + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"className\">" + className + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"functionName\">" + classMethod + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"Class_Lexical\">" + Double.toString(gWeigh.get(0)) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"Class_DatatypeProperty\">" + Double.toString(gWeigh.get(1)) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"Class_ObjectProperty\">" + Double.toString(gWeigh.get(2)) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"Class_SuperClass\">" + Double.toString(gWeigh.get(3)) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"Class_Object\">" + Double.toString(gWeigh.get(4)) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"ObjectProperty_Lexical\">" + Double.toString(gWeigh.get(5)) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"ObjectProperty_Class\">" + Double.toString(gWeigh.get(6)) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"ObjectProperty_Object\">" + Double.toString(gWeigh.get(7)) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"ObjectProperty_Cardinality\">" + Double.toString(gWeigh.get(8)) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"ObjectProperty_Relation\">" + Double.toString(gWeigh.get(9)) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"DatatypeProperty_Lexical\">" + Double.toString(gWeigh.get(10)) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"DatatypeProperty_Datatype\">" + Double.toString(gWeigh.get(11)) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"DatatypeProperty_DatatypeValue\">" + Double.toString(gWeigh.get(12)) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"DatatypeProperty_Cardinality\">" + Double.toString(gWeigh.get(13)) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"DatatypeProperty_Relation\">" + Double.toString(gWeigh.get(14)) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"DatatypeRelation_Lexical\">" + Double.toString(gWeigh.get(15)) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"DatatypeRelation_Domain\">" + Double.toString(gWeigh.get(16)) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"DatatypeRelation_Range\">" + Double.toString(gWeigh.get(17)) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"DatatypeRelation_SuperRelation\">"+ Double.toString(gWeigh.get(18)) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"ObjectRelation_Lexical\">" + Double.toString(gWeigh.get(19)) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"ObjectRelation_Domain\">" + Double.toString(gWeigh.get(20)) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"ObjectRelation_Range\">" + Double.toString(gWeigh.get(21)) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"ObjectRelation_SuperRelation\">" +Double.toString(gWeigh.get(22)) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"Object_Lexical\">" + Double.toString(gWeigh.get(23)) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"Object_DatatypePropertyInstance\">" + Double.toString(gWeigh.get(24)) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"Object_ObjectPropertyInstance\">" + Double.toString(gWeigh.get(25)) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"Object_Class\">" + Double.toString(gWeigh.get(26)) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"DatatypePropertyInstance_Lexical\">" + Double.toString(gWeigh.get(27)) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"DatatypePropertyInstance_DatatypeValue\">" + Double.toString(gWeigh.get(28)) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"DatatypePropertyInstance_Relation\">" + Double.toString(gWeigh.get(29)) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"ObjectPropertyInstance_Lexical\">" + Double.toString(gWeigh.get(30)) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"ObjectPropertyInstance_Object\">" + Double.toString(gWeigh.get(31)) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "<param name=\"ObjectPropertyInstance_Relation\">" + Double.toString(gWeigh.get(32)) + "</param>";f_out.write(dTW,0,dTW.length());f_out.newLine();
			dTW = "</alignmentAlgorithm>";f_out.write(dTW,0,dTW.length());f_out.newLine();			
         }
      catch(IOException e){
          System.out.println("Write Exception: ");System.out.println(e.toString());System.exit(0);
         }
      finally{
          try{
              f_out.close();out.close();
             }
          catch(IOException e){
              System.out.println("Close Exception: ");System.out.println(e.toString());System.exit(0);
             }
        } 
	}
	
	

}
