/**
 * 
 */
package ca.uqam.info.latece.sboa.inter.amatrix;

import java.util.TreeSet;

import no.uib.cipr.matrix.Matrix;

import ca.uqam.info.latece.sboa.inter.ograph.Edge;
import ca.uqam.info.latece.sboa.inter.ograph.VerticesPool;

/**
 * @author J.F. Djoufak
 *
 */
public interface AdjacencyMatrix {
	
	public void build(Edge[] eSet);
	
	public void build(String nam, String typ, Matrix mat, int[] lidVect, int[] cidVect);
	
	public String getType();
	public void setType(String typ);
	
	public String getName();
	public void setName(String nam);
	
	public int getNumberOfLines();
	public void setNumberOfLines(int lin);
	
	public int getNumberOfColums();
	public void setNumberOfColums(int col);
	
	public Matrix getMatrix();
	public void setMatrix(Matrix mat);
	
	public int[] getLineVerticeIds();
	public int[] getColVerticeIds();
	
	public int[] getStaticLineVerticeIds(int[] initialId, int sz);
	public int[] getStaticColVerticeIds(int[] initialId, int sz);
	
	public void insertVertice(TreeSet<Integer> foundLineIds,TreeSet<Integer> foundColIds);
	public void insertAllVertices(Edge[] eSet);
	
	public void viewMatrix(VerticesPool vPool);
	public void clearAll();
	
	public void updateWithStaticLineVertice(int[] initialId, int sz);
	public void updateWithStaticColVertice(int[] initialId, int sz);
	
	public int getLineIndice(int Id);
	public int getColumnIndice(int Id);
}
